{% extends 'base.html.twig' %}

{% block title %}Sócios{% endblock %}

{% block body %}
    <div class="container">
        <div class="row">
            <h3 class="col-10">Editar Sócio</h3>
        </div>
        <hr>
        <div class="card">
            <div class="card-body">
                <div class="form-group">
                    <label for="cpf">CPF</label>
                    <input type="text" class="form-control" id="cpf" maxlength="11">
                </div>
                <div class="form-group">
                    <label for="nome">Nome</label>
                    <input type="text" class="form-control" id="nome" maxlength="255">
                </div>
                <div class="form-group">
                    <label for="empresas">Empresas</label>
                    <select class="selectpicker form-control" data-live-search="true" id="empresas" multiple>
                    </select>
                </div>
                <button class="btn btn-primary" onclick="edit()">Salvar</button>
                <button class="btn btn-danger" onclick="remove()">Remover</button>
            </div>
        </div>
    </div>
{% endblock %}

{% block scripts %}
    <script type="application/javascript">
        let id = "{{ data['id'] }}";
        let cpf = $('#cpf');
        let nome = $('#nome');
        let empresas = $('#empresas');

        $.ajax({
            type: 'GET',
            url: `/api/empresas/`,
            data: {},
            dataType: 'json',
            success: function (data_empresas) {
                $.ajax({
                    type: 'GET',
                    url: `/api/socios/${id}`,
                    data: {},
                    dataType: 'json',
                    success: function (data_socio) {
                        cpf.val(data_socio.cpf);
                        nome.val(data_socio.nome);
                        let html = '';

                        let socio_empresas_ids = [];

                        for (let socio_empresa of data_socio.empresas)
                            socio_empresas_ids.push(socio_empresa.id);

                        for (let empresa of data_empresas) {
                            html += socio_empresas_ids.includes(empresa.id)
                                ? `<option value="${empresa.id}" selected>${empresa.nome_fantasia}</option>`
                                : `<option value="${empresa.id}">${empresa.nome_fantasia}</option>`;

                        }
                        empresas.html(html);
                        $('.selectpicker').selectpicker('refresh');
                    }
                });
            }
        });


        cpf.keypress(function (e) {
            if (e.which !== 8 && e.which !== 0 && (e.which < 48 || e.which > 57)) {
                e.preventDefault();
            }
        });

        function edit(){
            $.ajax({
                type: 'PUT',
                url: `/api/socios/${id}`,
                data: {
                    cpf: cpf.val().trim(),
                    nome: nome.val().trim(),
                    empresas: empresas.val()
                },
                dataType: 'json',
                success: function () {
                    window.location.reload();
                }
            });
        }

        function remove(){
            $.ajax({
                type: 'DELETE',
                url: `/api/socios/${id}`,
                dataType: 'json',
                success: function () {
                    window.location.replace('http://localhost:8000/socios');
                }
            });
        }
    </script>
{% endblock %}
